=== debian/changelog ===
lua-apr (0.23.2.dfsg-4) unstable; urgency=medium

  * Fix lintian warning adding ${misc:Depends} to the -doc package 
  * Fix watch file

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 14 Aug 2015 20:38:56 +0200

lua-apr (0.23.2.dfsg-3) unstable; urgency=medium

  * Pre-Depends: use misc:Pre-Depends and not multiarch-support 

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 14 Aug 2015 18:38:11 +0200

lua-apr (0.23.2.dfsg-2) unstable; urgency=medium

  * Fix test suite (Closes: #735830) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 18 Jan 2014 14:05:09 +0100

lua-apr (0.23.2.dfsg-1) unstable; urgency=low

  * Ship doc into a separate arch-all package since markdown, used to generate
    the doc, randomly obfuscates the email addresses and hence made the -dev
    package non multi-arch: same (Closes: #720022, thanks Andreas Beckmann for
    spotting this)
  * Add to the orig tarball a copy of the LICENSE 
  * Fix debian/copyright using Expat instead of MIT/X 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 17 Aug 2013 23:01:10 +0200

lua-apr (0.23.2+git-2) unstable; urgency=low

  * Build the docs using lua-discount

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 09 Aug 2013 15:17:26 +0200

lua-apr (0.23.2+git-1) unstable; urgency=low

  * Packaging moved to git 
  * Remove transitional packages

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 02 Apr 2012 20:28:00 +0200
