=== debian/control ===
Source: lua-apr
Section: interpreters
Priority: optional
Maintainer: Enrico Tassi <gareuselesinge@debian.org>
Build-Depends: debhelper (>= 8.1.3), dh-lua (>= 11), libapr1-dev, libaprutil1-dev, libaprutil1-dbd-sqlite3, libapreq2-dev, lua-discount
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/pkg-lua/lua-apr.git
Vcs-Browser: http://git.debian.org/?p=pkg-lua/lua-apr.git
Homepage: http://peterodding.com/code/lua/apr/

Package: lua-apr
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: Apache Portable Runtime library for the Lua language
 This package contains the bindings for the Apache Portable Runtime library.

Package: lua-apr-dev
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: lua-apr (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Section: libdevel
Description: Lua development files for the Apache Portable Runtime library
 This package contains the development files of the Apache Portable Runtime
 library bindings, useful to create a statically linked binary (like a
 C application or a standalone Lua interpreter).  

Package: lua-apr-doc
Depends: ${misc:Depends}
Architecture: all
Section: doc
Description: Lua documentation files for the Apache Portable Runtime library
 Documentation of lua-apr is shipped in this package.
